#include <vector>
#include <iostream>
#include <algorithm>

template <typename elementType>
class Multiply
{
public:
    elementType operator () (const elementType& elem1, 
        const elementType& elem2)
    {
        return (elem1 * elem2); 
    }
};

int main ()
{
    using namespace std;

    // Utworzenie dwóch przykładowych obiektów vector, z których każdy przechowuje po dziesięć liczb całkowitych.
    vector <int> vecMultiplicand, vecMultiplier;

    // Wstawienie wartości przykładowych od 0 do 9.
    for (int nCount1 = 0; nCount1 < 10; ++ nCount1)
        vecMultiplicand.push_back (nCount1);

    // Wstawienie wartości przykładowych od 100 do 109.
    for (int nCount2 = 100; nCount2 < 110; ++ nCount2)
        vecMultiplier.push_back (nCount2);

    // Trzeci kontener będzie przechowywał wyniki operacji mnożenia.
    vector <int> vecResult;

    // Zrobienie miejsca dla wyników operacji mnożenia.
    vecResult.resize (10);
    transform (    vecMultiplicand.begin (), // Zakres mnożenia.
                vecMultiplicand.end (), // Koniec zakresu.
                vecMultiplier.begin (),  // Wartości mnożnika.
                vecResult.begin (), // Zakres przechowujący wyniki.
                Multiply <int> () );    // Funkcja przeprowadzająca mnożenie.

    cout << "Zawartość pierwszego obiektu vector: " << endl;
    for (size_t nIndex1 = 0; nIndex1 < vecMultiplicand.size (); ++ nIndex1)
        cout << vecMultiplicand [nIndex1] << ' ';
    cout << endl;

    cout << "Zawartość drugiego obiektu vector: " << endl;
    for (size_t nIndex2 = 0; nIndex2 < vecMultiplier.size (); ++nIndex2)
        cout << vecMultiplier [nIndex2] << ' ';
    cout << endl << endl;

    cout << "Wyniki operacji mnożenia: " << endl;
    for (size_t nIndex = 0; nIndex < vecResult.size (); ++ nIndex)
        cout << vecResult [nIndex] << ' '; 

    return 0;
}
