template <typename T>
class smart_pointer
{
private:
    T* m_pRawPointer;
public:
    smart_pointer (T* pData) : m_pRawPointer (pData) {}    // Konstruktor.
    ~smart_pointer () {delete pData;};                    // Destruktor.

    // Konstruktor kopiujący.
    smart_pointer (const smart_pointer & anotherSP);
    // Operator przypisania.
    smart_pointer& operator= (const smart_pointer& anotherSP);    

    T& operator* () const        // Operator wyłuskiwania.
    {
        return *(m_pRawPointer);
    }

    T* operator-> () const        // Operator wyboru elementu składowego.
    {
        return m_pRawPointer;
    }
};
